"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = require("debug");
const debug = debug_1.default('telegraf:webhook');
function default_1(hookPath, updateHandler) {
    return async (req, res, next = () => {
        res.statusCode = 403;
        return res.end();
    }) => {
        debug('Incoming request', req.method, req.url);
        if (req.method !== 'POST' || req.url !== hookPath) {
            return next();
        }
        let body = '';
        for await (const chunk of req) {
            body += String(chunk);
        }
        let update;
        try {
            update = JSON.parse(body);
        }
        catch (error) {
            res.writeHead(415);
            res.end();
            debug('Failed to parse request body:', error);
            return;
        }
        try {
            await updateHandler(update, res);
        }
        catch (err) {
            res.writeHead(500);
            res.end();
            throw err;
        }
    };
}
exports.default = default_1;
